<!DOCTYPE html>
<html lang="en">
  <head>
    <title>System Monitor</title>
    {% assets "js_all"
    %}<script type="text/javascript" src="{{ ASSET_URL }}"></script>
    {% endassets %}
    <script>
      class ChartLine{
        addPoint(val){
          this.points.shift();
          for(var i in this.points){
            this.points[i].x = this.points[i].x + ((this.xAxisSize - 1) / this.points.length);
          }
          this.points.push(val);
          if(val.y && val.y > this.threshold){
            var event = $.Event('limitExceeded');
            event.value = val.y;
            event.name = this.title();
            $(document).trigger(event);
          }
        }
        title(){
          return this.constructor.name;
        }
        constructor(config){
          var points = new Array(config.size);
          for(var i = 0; i < config.size; i++) points[i] = {x: undefined, y: undefined};
          this.points = points;
          this.xAxisSize = config.xAxisSize;
          this.threshold = config.threshold;
        }
      }
      class CpuChartLine extends ChartLine{
        title(){
          return 'Cpu load';
        }
      }
      class MemChartLine extends ChartLine{
        title(){
          return 'Used memory';
        }
      }
      $(function(){
        var periodLength = 61;
        var threshold = 80;
        var cpuLine = new CpuChartLine({size: 61, xAxisSize: periodLength, threshold: threshold});
        var memLine = new MemChartLine({size: 21, xAxisSize: periodLength, threshold: threshold});
        const config = {
          type: 'line',
          data: {
            labels: Array.from(new Array(periodLength).keys()).reverse(),
            datasets: [
              {
                label: 'Cpu load (%)',
                backgroundColor: 'rgb(0, 0, 255)',
                borderColor: 'rgb(150, 150, 255)',
                data: cpuLine.points
              },
              {
                label: 'Used memory (%)',
                backgroundColor: 'rgb(255, 0, 0)',
                borderColor: 'rgb(255, 150, 150)',
                data: memLine.points
              }
            ]
          },
          options: {
            animation: {
              duration: 0
            }
          }
        };
        var chart = new Chart($('#chart'),config);
        $(document).on('limitExceeded', function(e){
          $('#threshold').prepend([
            '<li>',
            (new Date(e.timeStamp)).toLocaleTimeString(),
            e.name,
            e.value.toFixed(2) + '%',
            '</li>'
          ].join(' '));
        });
        var p = 0;
        var updater = function(){
          $.ajax({
            url: '/cpu',
            method: 'GET',
            success: function(json){
              cpuLine.addPoint({x: 0, y: json[0]});
              chart.update();
            }
          });
          if(p % 3 == 0){
            $.ajax({
              url: '/mem',
              method: 'GET',
              success: function(json){
                memLine.addPoint({x: 0, y: json[0]});
                chart.update();
              }
            });
          }
          p++;
        };
        setInterval(updater, 1000);
      });
    </script>
  </head>
  <body>
    <div>
      <canvas id="chart"></canvas>
      <ul id="threshold"></ul>
    </div>
  </body>
</html>